%  curvfit3.m
% Matlab file for Part 3 of the Curve Fitting module

disp('*********************************************')
disp('Part 3:  Linearization ')
disp('*********************************************')
disp('  ')

    format short

    disp('Step 1: ') 
    disp('Enter the data vectors for the U.S. Populations: ')
    disp(' ')
    disp('  times = 1900:10:1990; ')
    disp('  one = ones(10,1); ')
    disp('  t = (times - 1900)''; ')
    disp('  y = [75.996,91.972,105.711,122.775,131.669,...')
    disp('       150.697,179.323,203.185,226.546,248.710]''; ')
    disp('  ystar = log(y); ')
    disp('  one = ones(10,1); ')
    disp(' ') 
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')

    disp('----------------------------------------------------')
    disp('Step 1 (cont.): ')
    disp('Enter the command to form the matrix X whose ')
    disp('columns are one and t. ')
    disp(' ')
    disp('Then solve the normal equations for the coefficients ')
    disp('A and b.  Note: be sure to use ystar, not y.') 
    disp(' ')
    disp('Enter ')
    disp(' ')
    disp(' X = [one, t] ')
    disp(' ')
    disp('----------------------------------------------------')
    disp('Recall A = ln(a).  Find the exponential model ')
    disp('y = a*exp(b*t) corresponding to your solution.  ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------------')
    disp('Step 2: ')
    disp('Assuming the coefficients a and b ')
    disp('are entered into MATLAB, the following commands ')
    disp('allow you to plot the exponential model you just ')
    disp('found together with the U.S. Population data set. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  figure(1); clf ')
    disp('  plot(times,y,''bo''); hold on ')
    disp('  taxis = 1890:2:2000; ')
    disp('  tvals = taxis - 1900; ')
    disp('  ypred = a*exp(b*tvals); ')
    disp('  plot(taxis,ypred,''r'') ')
    disp('  axis([1890,2000,0,300]); ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    disp('----------------------------------------------')
    disp('Use MATLAB comments in your diary file to')
    disp('comment on the goodness of fit. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('-----------------------------------------------------')
    disp('Step 3:')
    disp('The following commands compute and plot the residuals. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  p= a*exp(b*t) ')
    disp('  resid = y - p ')
    disp('  figure(2); clf ')
    disp('  plot(times, resid, ''bo''); hold on ')
    disp('  plot(taxis, zeros(size(taxis,2),1), ''k'') ')
    disp('  axis([1890,2000, -10,10]); ')
    disp('  title(''Residual plot for exponential fit'') ')
    disp(' ')
    disp('-----------------------------------------------------')
    disp('Make the rest of the needed computations and ')
    disp('discuss the fit using MATLAB comments in your ')
    disp('diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('-------------------------------------------------')
    disp('Step 4:')
    disp('Enter the coeficients from the quadratic fit from')
    disp('Part 1 (call them a0, b0, c0 to avoid confusion with ')
    disp('the a and b above). ')
    disp(' ')
    disp('Then enter the commands to make the residual plot ')
    disp('for the quadratic fit. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  a0 = ?')
    disp('  b0 = ?')
    disp('  c0 = ?')
    disp(' ')
    disp('  p0= a0 + b0*t + c0*t.^2 ')
    disp('  resid0 = y - p0 ')
    disp('  figure(1); clf ')
    disp('  plot(times, resid0, ''ro''); hold on ')
    disp('  plot(taxis, zeros(size(taxis,2),1), ''k'') ')
    disp('  axis([1890,2000, -10,10]); ')
    disp('  title(''Residual plot for quadratic fit'') ')
    disp(' ')
    disp('-------------------------------------------------')
    disp('Use MATLAB comments in your diary file to compare')
    disp('the exponential fit to the quadratic fit. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('-------------------------------------------------')
    disp('Step 5: ') 
    disp('Enter the data vectors for the Small Data Set:')
    disp(' ')
    disp('  t = (1:4)'' ')
    disp('  y = [2.5, 8.0, 19.9, 50.0]'' ')
    disp('  one = ones(4,1); ')
    disp('  tstar = log(t); ')
    disp('  ystar = log(y); ')
    disp(' ') 
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('-------------------------------------------------')
    disp('Step 5 (cont.): ') 
    disp('Solve the least squares problem for the log-log')
    disp('data.  Use your results to solve for the ')
    disp('parameters a and b in the corresponding power ')
    disp('fit y = a*t^b.')
    disp(' ')
    disp('Give results and explain your steps by using MATLAB')
    disp('comments in your diary file. ')
    disp(' ') 
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------------')
    disp('Step 6: ')
    disp('Assuming the coefficients a and b ')
    disp('are entered into MATLAB, the following commands ')
    disp('allow you to plot the power model you just ')
    disp('found together with the Small Data Set. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  figure(1); clf ')
    disp('  plot(t,y,''bo''); hold on ')
    disp('  tvals = 0:0.1:5; ')
    disp('  ypred = a*tvals.^b; ')
    disp('  plot(tvals,ypred,''r'') ')
    disp('  axis([0,5,0,60]); ')
    disp(' ')
    disp('----------------------------------------------')
    disp('Use MATLAB comments in your diary file to')
    disp('comment on the goodness of fit. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------------')
    disp('Step 7:')
    disp('The following commands compute and plot the residuals. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  p= a*t.^b ')
    disp('  resid = y - p ')
    disp('  figure(2); clf ')
    disp('  plot(t, resid, ''bo''); hold on ')
    disp('  plot(tvals, zeros(size(tvals,2),1), ''k'') ')
    disp('  axis([0,5, -10,10]); ')
    disp('  title(''Residual plot for power fit'') ')
    disp(' ')
    disp('-----------------------------------------------------')
    disp('Make the rest of the needed computations and ')
    disp('discuss the fit using MATLAB comments in your ')
    disp('diary file. ')
    disp(' ')
    disp(' ')
    disp('----------------------------------------------')
    disp('To go on to part 4 of this module, ')
    disp('type: curvfit4')
    disp(' ')
